// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockApprovalRules is an autogenerated mock type for the ApprovalRules type
type MockApprovalRules struct {
	mock.Mock
}

// CreateApprovalRule provides a mock function with given fields: ctx, req
func (_m *MockApprovalRules) CreateApprovalRule(ctx context.Context, req *models.ApprovalRule) (*models.ApprovalRule, error) {
	ret := _m.Called(ctx, req)

	if len(ret) == 0 {
		panic("no return value specified for CreateApprovalRule")
	}

	var r0 *models.ApprovalRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ApprovalRule) (*models.ApprovalRule, error)); ok {
		return rf(ctx, req)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ApprovalRule) *models.ApprovalRule); ok {
		r0 = rf(ctx, req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ApprovalRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ApprovalRule) error); ok {
		r1 = rf(ctx, req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteApprovalRule provides a mock function with given fields: ctx, rule
func (_m *MockApprovalRules) DeleteApprovalRule(ctx context.Context, rule *models.ApprovalRule) error {
	ret := _m.Called(ctx, rule)

	if len(ret) == 0 {
		panic("no return value specified for DeleteApprovalRule")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ApprovalRule) error); ok {
		r0 = rf(ctx, rule)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetApprovalRuleByID provides a mock function with given fields: ctx, id
func (_m *MockApprovalRules) GetApprovalRuleByID(ctx context.Context, id string) (*models.ApprovalRule, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetApprovalRuleByID")
	}

	var r0 *models.ApprovalRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ApprovalRule, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ApprovalRule); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ApprovalRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetApprovalRuleByPRN provides a mock function with given fields: ctx, prn
func (_m *MockApprovalRules) GetApprovalRuleByPRN(ctx context.Context, prn string) (*models.ApprovalRule, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetApprovalRuleByPRN")
	}

	var r0 *models.ApprovalRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ApprovalRule, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ApprovalRule); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ApprovalRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetApprovalRules provides a mock function with given fields: ctx, input
func (_m *MockApprovalRules) GetApprovalRules(ctx context.Context, input *GetApprovalRulesInput) (*ApprovalRulesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetApprovalRules")
	}

	var r0 *ApprovalRulesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetApprovalRulesInput) (*ApprovalRulesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetApprovalRulesInput) *ApprovalRulesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ApprovalRulesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetApprovalRulesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateApprovalRule provides a mock function with given fields: ctx, rule
func (_m *MockApprovalRules) UpdateApprovalRule(ctx context.Context, rule *models.ApprovalRule) (*models.ApprovalRule, error) {
	ret := _m.Called(ctx, rule)

	if len(ret) == 0 {
		panic("no return value specified for UpdateApprovalRule")
	}

	var r0 *models.ApprovalRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ApprovalRule) (*models.ApprovalRule, error)); ok {
		return rf(ctx, rule)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ApprovalRule) *models.ApprovalRule); ok {
		r0 = rf(ctx, rule)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ApprovalRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ApprovalRule) error); ok {
		r1 = rf(ctx, rule)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockApprovalRules creates a new instance of MockApprovalRules. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockApprovalRules(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockApprovalRules {
	mock := &MockApprovalRules{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
